; subackb/asm - kjw/bqsd - 08/78 - version 3.0 - 11/82
;
; revised 03/16/83 - kjw
;
	PAGE
;
;	$UCOPY - special disk copy entry
;
UCOPY	RST	@08		;send linefeed
;
	DEFB	LF
	DEFB	ETX
;
	CALL	ONEDRIV		;fetch drive to copy
	LD	A,(DRIV)	;fetch binary drive
	LD	(SDRIVE),A	;save as source drive
	LD	A,(IY+0)	;get physical tracks
	LD	(TEMP3),A	;store it
	RST	@18		;to decimal ascii
	LD	(UCTC),A	;to the string
	LD	(UCTC+1),BC	;rest of it
	LD	(IY+7),0	;set unknown dos!
	LD	(IY+6),0	;single den/sides
	RST	@08		;another linefeed
;
	DEFB	LF
	DEFB	ETX
;
	CALL	DRVASC		;fetch ascii drive #
	LD	(UCDR),A	;save it
	CALL	DSTAT		;check if drive ready
	JP	NZ,GOBACK	;go if not ready!
	CALL	RESTORE		;move head to track 0
	JP	NZ,GOBACK	;go if not ready
;
;	allow long sectors to be read in on mod III
;
;iii*
	IF	MODIII
	LD	A,18H		;JR opcode
	LD	(RD3FIX),A	;for read
	LD	(WR3FIX),A	;for write
	ENDIF
;iii*
	XOR	A		;load zero
	LD	(TEMP0),A	;save current track
	LD	(TASKDRV),A	;force restore next acc.
	LD	IX,DAMBUFF	;init table pointer
;
;	looper to build track images in memory
;
;	IX => beginning of current track information
;	DE => pointer for next sector information
;	IX+0 - # sectors defined single den curr track
;	IX+1 - # sectors defined double den curr track
;
;	data follows for each sector
;	+0 - track #
;	+1 - head #
;	+2 - sector #
;	+3 - sector length
;	+4	4 = ID crc error
;		3 = DATA crc error
;		1&0 - address mark
;
UTLOOP	LD	(IX+0),0	;load 0 single den sects
	LD	(IX+1),0	;0 double den sectors
	PUSH	IX		;pass pointer to HL
	POP	DE		;DE => table beginning
	INC	DE		;bump by 2 bytes
	INC	DE		;DE => current sector loc
;
	LD	A,(TEMP0)	;fetch current track
	RST	@18		;to decimal ascii
	LD	(UCTR),A	;to the string
	LD	(UCTR+1),BC	;rest of it
	CALL	SHOMNY		;display current data
;
;	build table on current track
;
	LD	A,(IY+5)	;fetch flags
	AND	40H		;keep double step only
	LD	(IY+5),A	;put it back
	LD	(TEMP5),DE	;save current table
;
UTLP1	LD	(IY+6),0	;single density disk
	CALL	UTLOOP1		;fetch single den data
	LD	A,(KBDR2)	;read keyboard
	AND	8		;'S' key?
	JR	NZ,UTLP1	;try more SD if yes
	LD	(TEMP5),DE	;save current table
	LD	A,(FLAGB)	;get system flag
	BIT	4,A		;double den available?
	JR	NZ,UTLP3	;nope, go!
;
UTLP2	LD	(IY+6),0C0H	;double den disk
	CALL	UTLOOP1		;fetch double den data
	LD	A,(KBDR0)	;read keyboard
	AND	10H		;'D' key?
	JR	NZ,UTLP2	;attempt more DD if yes
;
UTLP3	CALL	UCTBL		;advance table
;
;	check if more to do
;
	LD	A,(TEMP0)	;fetch track
	INC	A		;+1
	LD	(TEMP0),A	;reset it
	CP	(IY+0)		;end of disk?
	JP	Z,UTFMT		;go format/copy!
	CALL	STEPIN		;step in a track
	JR	UTLOOP		;go next track
;
;	scan track for readable ID marks
;
UTLOOP1	LD	HL,INPUT	;ID I/O buffer
	LD	B,6		;length
	XOR	A		;load zero
	CALL	FILL		;clear buffer
;i/m*
	IF	MODI.OR.MAX80
	CALL	SELDEN		;select correct doubler
	ENDIF
;i/m*
	CALL	ADDR		;attempt to read ID
	CALL	NZ,ADDR		;2 tries if bad
	JR	Z,UTLOOP2	;go if no error
;
;	check if data was actually read in from
;	a fake sector
;
	LD	BC,0600H	;B=counter, C=checksum
UTCK1	LD	A,(HL)		;fetch ID byte
	ADD	A,C		;add to checksum
	LD	C,A		;update
	INC	HL		;bump pointer
	DJNZ	UTCK1		;check 'em all
	RET	Z		;return if nil data
;
;	allow 50 attempts at locating each new sector
;
UTLOOP2	LD	A,50		;reset counter
	LD	(TEMP1),A	;save counter
;
UTLOOP3	LD	A,(KBDR6)	;scan keyboard
	AND	8		;up arrow?
	RET	NZ		;yes, skip this track
;
	CALL	ADDR		;read ID marks
;
;	have ID field, check if already found
;
UTLOOP4	LD	A,(KBDR6)	;check for clear key hold
	AND	2		;pressed?
	JR	NZ,UTLOOP4	;yes, hold right here!
;
	CALL	IFTHER		;new sector found?
	JR	Z,UTLOOP5	;yes, go!
;
;	current ID already logged into table
;
	LD	A,(TEMP1)	;fetch current attempt
	DEC	A		;less one
	LD	(TEMP1),A	;put it back
	JR	NZ,UTLOOP3	;go if more attempts left
	RET			;track found!
;
;	new sector found, log it in the table
;
UTLOOP5	LD	(TEMP2),DE	;save table pointer
	LD	HL,INPUT	;point to ID buffer
	LD	BC,4		;4 bytes to move in
	LDIR			;move it in!
;
;	read the sector to determine CRC types
;
	PUSH	DE		;save current table end
	EXX			;save registers
	LD	A,(INPUT)	;get track
	LD	D,A		;pass to D for pre-comp
;i*
	IF	MODI
	LD	(FDCTRK),A	;track register
	LD	(FDCDAT),A	;data register
	ENDIF
;i*
;m*
	IF	MAX80
	CPL			;reverse bits
	LD	(FDCTRK),A	;fdc track register
	LD	(FDCDAT),A	;fdc data register
	ENDIF
;m*
;iii*
	IF	MODIII
	OUT	(FDCTRK),A	;track register
	OUT	(FDCDAT),A	;data register
	ENDIF
;iii*
	LD	A,(INPUT+2)	;get sector
;i*
	IF	MODI
	LD	(FDCSEC),A	;sector register
	ENDIF
;i*
;m*
	IF	MAX80
	CPL			;reverse bits
	LD	(FDCSEC),A	;to FDC
	ENDIF
;m*
;iii*
	IF	MODIII
	OUT	(FDCSEC),A	;sector register
	ENDIF
;iii*
	RES	7,(IY+5)	;set READ operation
	CALL	SELECT		;select drive
	CALL	FIXSET		;fetch read type
	LD	A,B		;get IBM bit
	OR	80H		;create read command
	LD	(RDTYPE),A	;save type of read
	POP	BC		;fetch buffer address
;
	PUSH	BC		;leave for restore
	CALL	READ1X		;special reader
	POP	HL		;restore buffer
;i*
	IF	MODI
	JR	Z,SPRD1		;go if no error
	AND	18H		;check for CRC error only
	CP	8		;data CRC error?
	JR	NZ,SPRD1	;go if not
	LD	(VECTOR3),A	;save error bits
	EX	AF,AF'		;get DAM type
	LD	(VECTOR3+1),A	;save it too
	CALL	FIXSET		;fetch IBM bit back
	LD	A,(RDTYPE)	;fetch read type
	XOR	B		;reverse IBM bit if set
	LD	(RDTYPE),A	;put it back
	LD	B,H		;pass buffer back
	LD	C,L		;yes?
	CALL	SELECT		;re-select drive
	CALL	READ1X		;try other density
	JR	Z,SPRD1		;go if no error
	LD	A,(VECTOR3+1)	;fetch original DAM
	EX	AF,AF'		;save here
	LD	A,(VECTOR3)	;fetch original error
	ENDIF
;i*
SPRD1	EXX			;swap back
;
;	save condition flags
;
	AND	18H		;keep not found/CRC
	LD	B,A		;save it
	LD	A,(RDTYPE)	;get read type
	RRCA			;move bit 3 => 2
	AND	4		;save bit 2 only
	OR	B		;combine it
	LD	B,A		;re-save it
	EX	AF,AF'		;get DAM type
	AND	3		;keep low 3 bits
	OR	B		;combine it
	LD	(DE),A		;put in table
	INC	DE		;bump table
;
;	add this sector to table
;
	BIT	7,(IY+6)	;single den?
	JR	Z,UTADDS	;yes, go!
	INC	(IX+1)		;bump double den
	JR	UTADDD		;continue
UTADDS	INC	(IX+0)		;bump single den
UTADDD	CALL	SHOMNY		;display info
	JP	UTLOOP2		;try for another!
;
;	display current sector found
;
SHOMNY	LD	A,(IX+0)	;fetch # SD sectors
	RST	@18		;to decimal ascii
	LD	(UCSD),A	;to string
	LD	(UCSD+1),BC	;rest of it
	LD	A,(IX+1)	;fetch # DD sectors
	RST	@18		;to decimal ascii
	LD	(UCDD),A	;to string
	LD	(UCDD+1),BC	;rest of it
;
	BIT	7,(IY+6)	;check density
	LD	A,'S'		;single?
	JR	Z,$+4		;go if yes
	LD	A,'D'		;double
	LD	(UCM),A		;to the string
;
	LD	HL,(TEMP2)	;get pointer
	LD	A,(HL)		;fetch track
	RST	@18		;to decimal ascii
	LD	(UCT),A		;to string
	LD	(UCT+1),BC	;rest
	INC	HL		;bump pointer
	LD	A,(HL)		;get head #
	RST	@18		;to decimal ascii
	LD	(UCH),A		;to string
	LD	(UCH+1),BC	;rest
	INC	HL		;bump table
	LD	A,(HL)		;get sector #
	RST	@18		;to decimal ascii
	LD	(UCS),A		;to string
	LD	(UCS+1),BC	;rest
	INC	HL		;bump pointer
	LD	A,(HL)		;get sector length
	RST	@18		;to decimal ascii
	LD	(UCL),A		;to the string
	LD	(UCL+1),BC	;rest
;
	INC	HL		;bump table
	LD	A,(HL)		;get pointer
	AND	3		;low 3 bits only
	LD	B,A		;save it
	ADD	A,A		;*2
	ADD	A,B		;*3
	LD	C,A		;pass to C
	LD	B,0		;BC = table offset
;
	PUSH	DE		;save
	PUSH	HL		;save
	LD	HL,MODDAT	;start of text table
	ADD	HL,BC		;HL => DAM type
	LD	C,3		;length
	LD	DE,UCD		;string
	LDIR			;move it in
;
	POP	HL		;restore table
	LD	A,(HL)		;fetch byte
	AND	18H		;false?
	LD	HL,UCFA		;'false pack'
	JR	NZ,$+5		;go if false
	LD	HL,UCNO		;'normal pack'
	LD	DE,UCN		;point to text
	LD	C,6		;length
	LDIR			;move it in
	POP	DE		;restore stack
;
	CALL	DLOFF		;disable 'dual'
	RST	@08		;display message
;
	DEFB	BOL
	DEFM	'Drive '
UCDR	DEFM	'x='
UCTC	DEFM	'xxx / Track '
UCTR	DEFM	'xxx / SD='
UCSD	DEFM	'xxx / DD='
UCDD	DEFM	'xxx'
	DEFB	LF
	DEFB	ETX
;
	LD	A,(IX+0)	;get # SD
	OR	(IX+1)		;or with # DD, any secs?
	JR	Z,UCNOT		;nothing!
;
	RST	@08		;display
UCM	DEFM	'xD Track '
UCT	DEFM	'xxx Head '
UCH	DEFM	'xxx Sector '
UCS	DEFM	'xxx Length '
UCL	DEFM	'xxx, '
UCD	DEFM	'xxx, '
UCN	DEFM	'xxxxxx'
	DEFB	UFEED
	DEFB	ETX
;
	JP	DLON		;dual on and return
;
UCNOT	RST	@08		;display
;
	DEFB	EOL		;clear line
	DEFB	UFEED		;up cursor
	DEFB	ETX		;done
;
	JP	DLON		;restore dual
;
UCFA	DEFM	'False '
UCNO	DEFM	'Normal'
;
;	check if sector already logged in table
;
IFTHER	BIT	7,(IY+6)	;single den?
	LD	A,(IX+0)	;get # SD secs
	JR	Z,IFTHER1	;go if yes
	LD	A,(IX+1)	;get # DD secs
IFTHER1	OR	A		;anything here?
	RET	Z		;nope, must be new!
;
	LD	C,A		;C = # entries in table
	PUSH	DE		;save DE from test
	LD	DE,(TEMP5)	;get tables start
;
IFTHER2	LD	HL,INPUT	;start of new table
	LD	B,4		;go for 4 chars
;
IFTHER3	LD	A,(DE)		;get a byte
	CP	(HL)		;match?
	JR	NZ,IFTHER4	;nope, try next one
	INC	HL		;bump pointer
	INC	DE		;next
	DJNZ	IFTHER3		;go for length
;
	POP	DE		;unstack pointer
	OR	-1		;set already there!
	RET			;match found!, return
;
IFTHER4	INC	DE		;bump pointer
	DJNZ	IFTHER4		;go till next entry
	INC	DE		;+ 1 for flags
;
	DEC	C		;less this entry
	JR	NZ,IFTHER2	;go if more left
;
	POP	DE		;unstack
	XOR	A		;return Z for NEW
	RET			;done!
;
;	disk image created!
;
UTFMT	INC	D		;bump MSB
	LD	E,0		;next even page
	LD	(FMTBUFF),DE	;save for buffer
;
UTFMORE	RST	@08		;display prompt
;
	DEFB	LF
	DEFB	LF
	DEFM	'Destination'
	DEFB	ETX
;
UTFMT0	CALL	ONEDRIV		;fetch drivespec
	LD	A,(DRIV)	;get binary drive
	LD	(DDRIVE),A	;save it
	LD	A,(TEMP0)	;get track count
	LD	(IY+0),A	;save track count
	LD	(IY+7),0	;set dos unknown!
	LD	A,(IY+5)	;get system flags
	AND	40H		;keep double step only
	LD	(IY+5),A	;update DCT
	RST	@08		;display linefeed
;
	DEFB	LF
	DEFB	ETX
;
;	ask if user wishes to view the formatted buffer
;
AIUWT	RST	@08		;display prompt
	DEFB	EOL		;clear line
	DEFM	'View Formatted Buffers? '
	DEFB	ETX
	LD	B,1		;one key
	RST	@10		;from keyboard
	JR	NZ,AIUWTX	;go if input
	LD	A,'N'		;default NO
AIUWTX	CALL	UCASE		;make upper case
	CP	'Y'		;yes?
	JR	Z,AIUWTY	;yes, go!
	CP	'N'		;no?
	JR	NZ,AIUWT	;neither, ask again
AIUWTY	LD	(SPFFLAG),A	;set flag
;
	RST	@08		;display linefeed
;
	DEFB	LF
	DEFB	ETX
;
	CALL	DRVSAME		;source & dest same?
	CALL	Z,MNTDES	;yes, mount DEST disk
	CALL	DSTAT		;check disk status
	JR	NZ,UTFMT0	;go if drive not ready
	CALL	RESTORE		;move head to track 0
	JR	NZ,UTFMT0	;go if not in system
;
	CALL	DRVASC		;get ascii drive #
	LD	(UTFMD),A	;to the message
	XOR	A		;load zero
	LD	(TEMP0),A	;set current track
	LD	IX,DAMBUFF	;start of table
;
UTFMT1	RST	@18		;to decimal ascii
	LD	(UTFMC),A	;to string
	LD	(UTFMC+1),BC	;rest
	LD	A,(IX+0)	;get # SD secs
	PUSH	AF		;save for re-fetch
	RST	@18		;decimal ascii
	LD	(UTFMA),A	;to string
	LD	(UTFMA+1),BC	;rest
	LD	A,(IX+1)	;set # DD secs
	PUSH	AF		;save for re-fetch
	RST	@18		;decimal ascii
	LD	(UTFMB),A	;to string
	LD	(UTFMB+1),BC	;rest
	POP	BC		;B = (IX+1)
	POP	AF		;A = (IX+0)
	RST	@08		;display message
;
	DEFB	BOL
	DEFM	'Formatting Drive '
UTFMD	DEFM	'x Track '
UTFMC	DEFM	'xxx / SD='
UTFMA	DEFM	'xxx / DD='
UTFMB	DEFM	'xxx'
	DEFB	ETX
;
	OR	B		;any sectors?
	JR	Z,UTFMT2	;go if nil!
;
	PUSH	IY		;save DCT
	CALL	SPBUILD		;special builder
	POP	IY		;restore DCT
;
;	check for buffer display between tracks
;
	LD	A,'$'		;get flag
SPFFLAG	EQU	$-1
	CP	'Y'		;yes?
	JR	NZ,UTFMT5	;go if not!
	LD	(UTFMT7),IY	;pass IY
	LD	BC,(FMTBUFF)	;start of buffer
	LD	HL,UTFMT6	;return vector
	LD	(VECTOR4),HL	;save it
	JP	DOADDR0		;display and go utfmt6
;
UTFMT6	RST	@08		;clear screen
	DEFB	CLSF		;clear & frame
	DEFB	ETX		;end of text
	LD	IY,$		;reload IY
UTFMT7	EQU	$-2
	LD	A,(KBDR6)	;get keyboard
	AND	2		;clear key?
	JR	Z,UTFMT5	;go if not!
	LD	A,'N'		;turn off display
	LD	(SPFFLAG),A	;save flag
;
UTFMT5	CALL	SPFMT		;special formatter
UTFMT2	LD	A,(TEMP0)	;get current track
	INC	A		;bump it
	LD	(TEMP0),A	;update track
	CP	(IY+0)		;at disk end?
	JP	Z,UTCOPY	;go copy if done!
	PUSH	AF		;save track
	CALL	UCTBL		;advance table
	CALL	STEPIN		;move in one track
	POP	AF		;A = track
	JP	UTFMT1		;go next track
;
;	special build track routine
;
SPBUILD	PUSH	IX		;pass IX to IY
	POP	IY		;table start
	INC	IY		;bump past length bytes
	INC	IY		;2 of 'em
	LD	HL,(FMTBUFF)	;start of buffer
	CALL	CLRBUFF		;clear out buffer
;
	LD	BC,0		;reset byte count
	CALL	SBUILD		;build single density
	LD	(TEMP8),BC	;save byte count
	LD	(TEMP7),HL	;save DD buffer
	LD	BC,0		;reset counter
	CALL	DBUILD		;build double density
	LD	(TEMP9),BC	;save byte count
	RET			;done, track created!
;
;	build single density portion
;
SBUILD	LD	A,(IX+0)	;get # SD sectors
	OR	A		;anything?
	RET	Z		;nope, no data!
	LD	C,A		;pass # to C
	XOR	A		;allow multi length secs
	LD	DE,GAPSNG	;gaps for single den
	JR	SDBUILD		;go common
;
DBUILD	LD	A,(IX+1)	;get # DD sectors
	OR	A		;anything?
	RET	Z		;nope, done!
	LD	C,A		;pass # to C
	LD	A,-1		;sec len's mod 3
	LD	DE,GAPDBL	;gaps for double den
;
SDBUILD	LD	(VECTOR1),HL	;save ptr to comp length
	LD	(LENFLAG),A	;pass length flag
	CALL	MOVEIN		;pre-index gap
	CALL	MOVEIN		;pre-index sync
	CALL	MOVEIN		;pre-index sync
	LD	(HL),0FCH	;index marker
	INC	HL		;bump buffer
	LD	(VECTOR2),DE	;save table pointer
;
SDBLDLP	LD	DE,(VECTOR2)	;get table for sectors
	CALL	MOVEIN		;pre-id gap
	CALL	MOVEIN		;pre-id sync
	CALL	MOVEIN		;pre-id sync
	LD	(HL),0FEH	;ID header
	INC	HL		;bump buffer
	LD	B,4		;4 bytes to move
;
SDLP0	LD	A,(IY)		;get table byte
	LD	(HL),A		;to buffer
	INC	IY		;bump table
	INC	HL		;bump buffer
	DJNZ	SDLP0		;continue
;
	LD	A,(IY+0)	;get CRC bits
	AND	18H		;check 4/3
	CP	18H		;ID error?
	LD	A,0F7H		;CRC generator
	JR	NZ,$+4		;go if no error
	LD	A,-1		;place false CRC
	LD	(HL),A		;to buffer
	INC	HL		;bump buffer
;
	CALL	MOVEIN		;pre-data gap
	CALL	MOVEIN		;pre-data sync
	CALL	MOVEIN		;pre-data sync
	LD	A,(IY+0)	;get CRC bits again
	AND	18H		;check 4/3
	CP	10H		;DATA error?
	JR	Z,SDSKP		;skip if yes!
;
	LD	A,(IY+0)	;get CRC again
	CPL			;reverse bits
	AND	3		;low 2 bits only
	OR	0F8H		;create proper header
	LD	(HL),A		;install header
	INC	HL		;bump it
	LD	A,(IY+0)	;get CRC again
	AND	18H		;check 4/3
	CP	8		;data CRC?
	JR	Z,SDSKP		;skip if yes!
;
;	fill data field
;
	PUSH	BC		;save sector counter
;i*
	IF	MODI
	CALL	FIXSET		;compute IBM bit
	LD	A,(IY+0)	;get from table
	ADD	A,A		;shift left one bit
	AND	8		;keep bit 3 only
	CP	B		;IBM flag correct?
	JR	Z,SPBLDOK	;yes, go!
;
;	non-ibm, compute length
;
	PUSH	HL		;save it
	LD	HL,16		;16 bytes / sector length
	LD	C,(IY-1)	;get length byte
	JR	SPBLDNI		;go non-ibm compute
	ENDIF
;i*
SPBLDOK	LD	BC,128		;length for 0
	LD	A,(IY-1)	;get length byte
	OR	A		;length = 0?
	JR	Z,SDHLN		;have length, go!
	LD	C,A		;pass to C
	LD	A,'$'		;get length flag
LENFLAG	EQU	$-1
	OR	A		;zero?
	JR	Z,LEN256	;yes, compute length
	LD	A,(IY-1)	;get length back
	AND	3		;3 only
	LD	BC,128		;length 0
	JR	Z,SDHLN		;go if yes
	LD	BC,256		;length 1
	DEC	A		;1?
	JR	Z,SDHLN		;go if yes
	LD	BC,512		;length 2
	DEC	A		;2?
	JR	Z,SDHLN		;go if yes
	LD	BC,1024		;length 3
	JR	SDHLN		;continue
;
LEN256	PUSH	HL		;save it
	LD	HL,256		;length *1
SPBLDNI	CALL	MULT		;HL = length
	LD	B,H		;pass to BC
	LD	C,L
	POP	HL		;restore buffer
SDHLN	LD	(HL),0		;load a zero
	INC	HL		;bump pointer
	DEC	BC		;less byte counter
	LD	A,B		;any more?
	OR	C
	JR	NZ,SDHLN	;go if yes
	POP	BC		;restore sector counter
	LD	(HL),0F7H	;install CRC
	INC	HL		;bump buffer
;
SDSKP	INC	IY		;bump pointer to next
	DEC	C		;less this sector
	JP	NZ,SDBLDLP	;go if more to do
	CALL	MOVEIN		;load gap
	LD	BC,(VECTOR1)	;get buffer start
	PUSH	HL		;save buffer
	OR	A		;clear carry
	SBC	HL,BC		;HL = length
	LD	B,H		;pass to BC
	LD	C,L		;BC = byte count
	POP	HL		;restore buffer
	RET			;done!
;
;	gap tables for single/double density
;
GAPSNG	DEFB	16,0FFH		;pre-index gap
	DEFB	03,000H		;pre-index sync
	DEFB	03,000H		;pre-index sync
;
	DEFB	12,0FFH		;pre-id gap
	DEFB	03,000H		;pre-id sync
	DEFB	03,000H		;pre-id sync
;
	DEFB	10,0FFH		;pre-data gap
	DEFB	02,000H		;pre-data sync
	DEFB	02,000H		;pre-data sync
;
	DEFB	16,0FFH		;gap before double den
;
GAPDBL	DEFB	32,04EH		;pre-index gap
	DEFB	12,000H		;pre-index sync
	DEFB	03,0F6H		;pre-index sync
;
	DEFB	22,04EH		;pre-id gap
	DEFB	12,000H		;pre-id sync
	DEFB	03,0F5H		;pre-id sync
;
	DEFB	24,04EH		;pre-data gap
	DEFB	08,000H		;pre-data sync
	DEFB	03,0F5H		;pre-data sync
;
	DEFB	00,04EH		;post data gap
;
;	special write track code
;
;	ENT	(fmtbuff) = start of track image
;		(temp8)   = byte count for single den
;		(temp9)   = byte count for double den
;
SPFMT	CALL	SELECT		;select drive
	RET	NZ		;hardware error!
;
;iii*
	IF	MODIII
	LD	BC,(FMTBUFF)	;get data start
	LD	A,(TEMP0)	;get track
	LD	D,A		;save for pre-comp
	LD	(IY+6),0	;setup for single den
	CALL	SETNMI		;setup for NMI
	INC	E		;bump mask
	LD	BC,(TEMP8)	;get byte count
	LD	A,B		;anything single den?
	OR	C		;yes?
	JR	NZ,SPFM0	;yes, go!
	SET	7,D		;set double density
	LD	BC,(TEMP9)	;get double den bytes
	LD	A,D		;get command
	RES	6,A		;wait off
	OUT	(FDCSEL),A	;set double den!
SPFM0	LD	A,0F0H		;write track command
	OUT	(FDCCMD),A	;issue command
	CALL	DSKSLO		;wait for status
SPFM1	IN	A,(FDCCMD)	;read status
	AND	E		;bit 1 ready?
	JP	PO,SPFM1	;wait for ready
	LD	A,(HL)		;fetch byte from buffer
	OUT	(FDCDAT),A	;give to FDC
	INC	HL		;bump buffer
	DEC	BC		;less this byte
	DEC	E		;less mask
;
SPFM2	IN	A,(FDCCMD)	;read status
	AND	E		;bit 1 ready?
	JR	Z,SPFM2		;wait if not
	LD	A,(HL)		;get buffer byte
	OUT	(FDCDAT),A	;to FDC
	INC	HL		;bump buffer
	DEC	BC		;less this byte
;
SPFM3	LD	A,D		;get wait command
	OUT	(FDCSEL),A	;go wait states
	LD	A,(HL)		;fetch buffer byte
	OUT	(FDCDAT),A	;to controller
	INC	HL		;bump buffer
	DEC	BC		;less byte counter
	LD	A,B		;any more?
	OR	C
	JR	NZ,SPFM3	;go if more
	BIT	7,D		;double now?
	JR	NZ,SPFM5	;go if yes!
	LD	BC,(TEMP9)	;get double den bytes
	LD	A,B		;anything?
	OR	C		;any DD?
	JR	Z,SPFM5		;pad single density
	SET	7,D		;set double density
;
SPFM4	LD	A,D		;get wait command
	OUT	(FDCSEL),A	;to controller
	LD	A,(HL)		;get buffer byte
	OUT	(FDCDAT),A	;to controller
	INC	HL		;bump buffer
	DEC	BC		;less byte counter
	LD	A,B		;any more?
	OR	C
	JR	NZ,SPFM4	;go if yes
;
;	send zeroes in current density till interrupt
;
SPFM5	LD	A,D		;get wait command
	OUT	(FDCSEL),A	;to controller
	XOR	A		;load zero
	OUT	(FDCDAT),A	;data byte 0
	JR	SPFM5		;wait for interrupt!
	ENDIF
;iii*
;i/m*
	IF	MODI.OR.MAX80
	LD	(IY+6),0	;set single density
	CALL	SELDEN		;select chip
	LD	BC,(TEMP9)	;get # bytes DD
	LD	A,B		;anything?
	OR	C
	JR	Z,SPFM1		;go if nil
	LD	(IY+6),0C0H	;set double density
	CALL	SELDEN		;select chip
	LD	HL,(TEMP8)	;get # bytes SD
	LD	A,H		;anything?
	OR	L
	JR	Z,SPFM1		;go if nil!
;
;	since the mod I has 2 separate disk controllers
;	for single and double density, the procedure
;	is quite different.  In the Mod III, we can
;	change density in the middle of the write track
;	command due to the single FDC.  In the Mod I,
;	if we change controllers, the active command
;	is not passed to the new controller and must
;	be reset.  This means that we would overwrite
;	data onto the same portion of the track and
;	would not accomplish the dual track density.
;	Instead, we will compute the number of bytes
;	that are to be written out in single density,
;	and multiply that times the double density
;	compression ratio (1.8), and decrement our
;	buffer pointer by the corresponding amount.
;	Then we will write out the full track in
;	double density, of which the first portion of
;	the track will be dummy data.  Then we
;	will re-format the track in single density,
;	counting the bytes, and interrupt the controller
;	at the precise moment to preserve the
;	back half of the track which is our DD portion.
;
	LD	B,0		;BHL = # bytes
	LD	A,18		;multiply x 18
	CALL	TMULT		;BHLA = BHL x A
	LD	B,H
	LD	H,L
	LD	L,A
	LD	A,10		;divide / 10
	CALL	TDIVD		;BHL / A = BHL:A
	EX	DE,HL		;DE = length
	LD	HL,(TEMP7)	;get DD start
	OR	A		;clear carry flag
	SBC	HL,DE		;HL => dummy data
	LD	B,H		;pass to BC
	LD	C,L		;BC => buffer
;
	CALL	SPFM1A		;format double den
	LD	(IY+6),0	;set single den
	CALL	SELDEN		;select chip
	LD	BC,(TEMP8)	;get # SD bytes
	LD	DE,(FMTBUFF)	;start SD data
	LD	HL,FDCCMD	;FDC command reg
	CALL	SELECT		;re-select drive
	RET	NZ		;return if error
	LD	A,0F4H		;write track command
;m*
	IF	MAX80
	CPL			;reverse bits
	ENDIF
;m*
	LD	(HL),A		;give to FDC
	CALL	DSKSLO		;wait for status
SPFM2	LD	A,(HL)		;get status
;m*
	IF	MAX80
	CPL			;reverse status
	ENDIF
;m*
	BIT	1,A		;ready for byte?
	JR	Z,SPFM2		;wait if not!
	LD	A,(DE)		;get buffer byte
;m*
	IF	MAX80
	CPL			;reverse data
	ENDIF
;m*
	LD	(FDCDAT),A	;to FDC
	INC	DE		;bump buffer
	DEC	BC		;less byte count
	LD	A,B		;any more?
	OR	C		;yes?
	JR	NZ,SPFM2	;go if more
	JP	INTFDC		;immediate interrupt!
;
SPFM1	LD	BC,(FMTBUFF)	;get format buffer
SPFM1A	JP	WRITETR		;write track in full!
	ENDIF
;i*
;
;	perform actual sector transfer here
;
UTCOPY	LD	A,(WHERE)	;fetch sub-menu flag
	CP	3		;special formatter?
	JP	Z,UTCOPYX	;yes, completed!
;
	RST	@08		;display header
;
	DEFB	LF
	DEFM	'Copying'
	DEFB	LF
	DEFB	ETX
;
	LD	IX,DAMBUFF	;start of table
	XOR	A		;load zero
	LD	(TEMP0),A	;set current track
;
UTCOPY1	LD	A,(SDRIVE)	;fetch source drive
	CALL	SETDRV		;setup for I/O
	CALL	DRVSAME		;source/dest same drive?
	CALL	Z,MNTSRC	;yes, mount source disk
;
	LD	A,(TEMP0)	;get track
	LD	D,A		;pass to D
	CALL	SEEK		;move head to track
	LD	(IY+6),0	;set single density
	PUSH	IX		;pass IX to HL
	POP	HL		;HL => table
	INC	HL		;past two byte length
	INC	HL
	LD	A,(IX+0)	;get # SD sectors
	OR	A		;anything?
	LD	BC,(FMTBUFF)	;start of I/O buffer
	CALL	NZ,UTLOAD	;load sectors
	LD	(IY+6),0C0H	;set double density
	LD	A,(IX+1)	;get # DD sectors
	OR	A		;anything?
	CALL	NZ,UTLOAD	;load sectors
;
	LD	A,(DDRIVE)	;fetch dest drive
	CALL	SETDRV		;setup for I/O
	CALL	DRVSAME		;source/dest same?
	CALL	Z,MNTDES	;mount dest disk
	LD	A,(TEMP0)	;get track
	LD	D,A		;pass for seek
	CALL	SEEK		;move head to track
	LD	(IY+6),0	;set single den
	PUSH	IX		;pass IX to HL
	POP	HL		;HL => table
	INC	HL		;bump past lengths
	INC	HL
	LD	A,(IX+0)	;get # SD secs
	OR	A		;anything?
	LD	BC,(FMTBUFF)	;start of buffer
	CALL	NZ,UTSAVE	;write buffer
	LD	(IY+6),0C0H	;set double density
	LD	A,(IX+1)	;get # DD secs
	OR	A		;anything?
	CALL	NZ,UTSAVE	;write if yes
;
	CALL	UCTBL		;bump table
	LD	A,(TEMP0)	;fetch current track
	INC	A		;+1
	LD	(TEMP0),A	;put it back
	CP	(IY+0)		;end of disk?
	JP	NZ,UTCOPY1	;go next track!
;
;	completed!
;
UTCOPYX	RST	@08		;display linefeed
;
	DEFB	LF
	DEFB	ETX
;
UTCOPY2	RST	@08		;display prompt
;
	DEFB	EOL
	DEFM	'Another Copy? '
	DEFB	ETX
;
	LD	B,3		;3 char input
	RST	@10		;get from keyboard
	JR	Z,UTCOPY2	;wait for input
	CALL	UCASE		;make upper case
	CP	'N'		;no?
	JP	Z,GOBACK	;nope, back to menu
	CP	'Y'		;yes?
	JR	NZ,UTCOPY2	;go if neither
	JP	UTFMORE		;go one more copy
;
;	compute offset to next table position
;
UCTBL	PUSH	HL		;save
	PUSH	DE		;save
	PUSH	BC		;save
	LD	L,(IX+0)	;get # single den
	LD	C,(IX+1)	;get # double den
	LD	H,0		;set MSB to 0
	LD	B,H		;both to 0
	ADD	HL,BC		;HL = # sectors
	LD	C,5		;5 bytes / sector
	CALL	MULT		;HL = table offset
	INC	HL		;+ 2 for length bytes
	INC	HL
	EX	DE,HL		;DE = offset
	ADD	IX,DE		;IX => next location
	POP	BC		;unstack
	POP	DE		;unstack
	POP	HL
	RET			;done, IX => next loc.
;
;	load track from special format
;
UTLOAD	LD	DE,READ1X	;read routine
	RST	@08		;display message
;
	DEFB	BOL
	DEFM	'Reading '
	DEFB	ETX
;
	JR	UTLDSV		;go common
;
UTSAVE	LD	DE,WRITE1X	;special write
	RST	@08		;display message
	DEFB	BOL
	DEFM	'Writing '
	DEFB	ETX
;
UTLDSV	LD	(UTSCALL),DE	;save vector
	LD	E,A		;pass # sectors
	LD	A,(TEMP0)	;get track
	PUSH	BC		;save from ascii
	RST	@18		;to decimal ascii
	LD	(UTLDT),A	;to string
	LD	(UTLDT+1),BC	;rest
	CALL	DRVASC		;get ascii drive #
	LD	(UTLDD),A	;to string
	LD	A,'S'		;single den?
	BIT	7,(IY+6)	;yes?
	JR	Z,$+4		;go if yes
	LD	A,'D'		;double den
	LD	(UTLDS),A	;to the string
	RST	@08		;display message
;
	DEFM	'Drive '
UTLDD	DEFM	'x, Track '
UTLDT	DEFM	'xxx, '
UTLDS	DEFM	'xDensity'
	DEFB	ETX
	POP	BC		;restore buffer
;
UTLDSVL	PUSH	DE		;save # sectors
	LD	A,(HL)		;get track
	LD	D,A		;pass to D
;i*
	IF	MODI
	LD	(FDCTRK),A	;to FDC track reg
	LD	(FDCDAT),A	;to FDC data register
	ENDIF
;i*
;m*
	IF	MAX80
	CPL			;reverse bits
	LD	(FDCTRK),A	;to fdc track reg
	LD	(FDCDAT),A	;to fdc data reg
	ENDIF
;m*
;iii*
	IF	MODIII
	OUT	(FDCTRK),A	;to FDC track reg
	OUT	(FDCDAT),A	;to FDC data register
	ENDIF
;iii*
	INC	HL		;bump table
	INC	HL		;twice
	LD	A,(HL)		;get sector
	LD	E,A		;pass to E
;i*
	IF	MODI
	LD	(FDCSEC),A	;to FDC sector reg
	ENDIF
;i*
;m*
	IF	MAX80
	CPL			;reverse bits
	LD	(FDCSEC),A	;to sector reg
	ENDIF
;m*
;iii*
	IF	MODIII
	OUT	(FDCSEC),A	;to FDC sector reg
	ENDIF
;iii*
	INC	HL		;bump table
	INC	HL		;twice to flags
	LD	A,(HL)		;get flags
	AND	18H		;check for errors
	JR	NZ,UTLDSVN	;go next sector if error
;
	PUSH	BC		;save it
	CALL	FIXSET		;load B with IBM bit
	LD	A,(HL)		;get flags again
	ADD	A,A		;shift left 1 bit
	AND	B		;combine with saved bit
	LD	B,A		;save temp
	OR	80H		;create read command
	LD	(RDTYPE),A	;save for read
	LD	A,(HL)		;fetch DAM marks
	AND	C		;mask with saved
	OR	B		;combine with IBM bit
	OR	0A0H		;create write command
	LD	(WRTYPE),A	;save for write
	POP	BC		;restore buffer
	CALL	SELECT		;select drive
;
	PUSH	HL		;save table
	CALL	$		;read/write no seek!
UTSCALL	EQU	$-2
	POP	HL		;restore table
	LD	BC,(TEMPFF)	;get new buff pointer
;
UTLDSVN	POP	DE		;restore # sectors
	INC	HL		;bump table
	DEC	E		;less this sector
	JR	NZ,UTLDSVL	;go looper if more
	RET			;else buffer full/empty
;
;	alternate serial storage area
;
SERSAV2	DEFB	0,0,0,0,0,0,0,0
	DEFB	0,0,0,0,0,0,0,0
;
